#!/bin/bash
declare TOP=0 # pointer to stack top 
TEMP= 
declare -a STACK 
push()
{
    if [ -z "$1" ] 
    then
        return
    fi
    while [ $# != 0 ] 
    do
        let TOP=TOP+1 
        STACK[$TOP]=$1 
        shift 
    done
    return
}

pop()
{
    TEMP= #clear temp
    if [ "$TOP" = "0" ] 
    then
        echo " waf! check why pop empty stack."
        return
    fi
    TEMP=${STACK[$TOP]}
    unset STACK[$TOP]
    let TOP=TOP-1
    return
}

show_stack()
{
    echo "----------STACK DUMP--------------"
    for i in ${STACK[@]}
    do
        echo $i
    done
    echo "TOP=$TOP"
}


# if we see lbe-hide then comment out the whole method use //
# method begin {  which is the first line following by lbe-hide
# next stuff is to find the end pos
# if when lbe-hide met but stack is not empty we just ignore

annotation_hide="lbe.annotation.hide"
dahide(){
 for file in src/main/java/com/lbe/mdremote/client/*.java   src/main/java/com/lbe/mdremote/common/*.java
 do
    nr=0
    hide=0
    cat $file | while read line
    do
      let nr=nr+1
      echo "$line" | grep "$annotation_hide" >/dev/null 2>&1
      if [ $? -eq 0 ] && [ $TOP -eq 0 ]; then
        hide=1;
        continue
      fi
      #deal one line hide
      echo "$line" | grep ";" >/dev/null 2>&1
      if [[ $hide -eq 1 && $? -eq 0 && $TOP -eq 0 ]];then
          if [[ $1 = "--confirm-hide"  && ! $line =~ ^//  ]];then
              sed -i "$nr s/^/\/\//" $file
          elif [[ $1 = "--no"  &&  $line =~ ^//  ]];then
              sed -i "$nr s/\/\///" $file
          fi
          hide=0
          continue
       fi

      echo "$line" | grep "{" >/dev/null 2>&1
      if [ $hide -eq 1 -a $? -eq 0 -a $TOP -eq 0 ];then
          if [ $1 = "--confirm-hide" ];then
              sed -i "$nr s/^/\/\//" $file     
          elif [ $1 = "--no" ];then
              if [[ ! $line =~ ^// ]];then
                  echo " return now, uncomment alreay. "
                  return
              fi
              sed -i "$nr s/\/\///" $file 
          fi
          push { 
          # show_stack
          continue
      fi

      if [ $TOP -ne 0 ];then
          if [ $1 = "--confirm-hide" ];then
              sed -i "$nr s/^/\/\//" $file     
          elif [ $1 = "--no" ];then
              sed -i "$nr s/\/\///" $file 
          fi
      fi

      echo "$line" | grep "}" >/dev/null 2>&1
      if [ $TOP -ne 0 -a $? -eq 0 ];then 
          pop
          #show_stack
          if [ $TOP -eq 0 ];then
              hide=0
          fi
      fi

      echo "$line" | grep "{" >/dev/null 2>&1

      if [ $hide -eq 1 -a $? -eq 0 ];then
          push {
          #show_stack
      fi

    done
done
}

showUsage(){
    echo " da_codehide --confirm-hide : to comment out the hide methods marked by:  ${annotation_hide}"
    echo " da_codehide --no  : to uncomment the hide code for inner use"
}


if [ $# != 1 ] || [ $1 != '--confirm-hide' -a $1 != '--no' ];then
    echo " reject! check usage:"
    showUsage
    exit 2
fi

dahide $1
echo "Finished."
